// express 프레임워크
const express = require('express');
const router = express.Router();

// firebase Admin 써드파티 미들웨어 
const admin = require('firebase-admin'); 
// firebase Admin 초기화 
const firebaseAdmin = admin.initializeApp({ 
    credential: admin.credential.cert({
        "type": "service_account",
        "project_id": "unity3dfirebase",
        "private_key_id": "edbebf73a4b550f7242053d41adc1a1e0d769199",
        "private_key": "-----BEGIN PRIVATE KEY-----\nMIIEvgIBADANBgkqhkiG9w0BAQEFAASCBKgwggSkAgEAAoIBAQCsdORI/J9kWwrR\nYFWZuuF/XjyxQgLQGrsC9dqbRlM5h5OAbkZB/Jp4OqTGsAzex8i7k1Pn7i9ErU6I\nAvnhsif7j/cLJ8hZ4LIUkPW7Wu9DWtyyZjltmA5k2/zv14ekhPg8RDDVPLnTDYMV\nEqrmK4OAnnmttJMorImVtetFf4gRaFJr4gD/ArEALjjuY8vSQoRftpWr0Q8bEHDh\nAXgPn8yMnSXevUgTykIYhKwo/JJ5LgzR7o/dporddU1eWK+iYWo0Eu+lOICMMnhG\nEaeXQ7svHCiXfvxofuvxZURQ257uyiTt7nP7K4OhsA0KObzHc3BL63mqDSo65M5n\n9654Z2KRAgMBAAECggEACAfoSso4C/hw/QYWhmWqMzNRJToIBbPkKioG+smGfgly\nIeSnJFLq+8ogIUAfVIKLA2OQrTf6ZVRvi0Ydzj5TJIcnct89fvEuEDO3iPi3mqd3\ndPe6TEzsvEXbgtNcT2a0mDqrgX3MWeecepWkQrq1BLJpXS1cpJcmtkOPlLlwvZeB\nmwafou5CufG2GXFwW1irPvoOpBcF+P5KWXsbjjbccxtb2RTYxE17BmogHG2nKEHj\nas9Ag4LyLELfMDfk3ZWSLNbwMDChr2j/Z4T69d7mjCl7S3wlXaFGBGIKQ63IsGd1\nk8XrUX79tWVj076Ks9LsfAH8QGLERvaDzxcNtucHqQKBgQDXPgiAmV4aYcOySDzn\nvt8wSI1kKJX/IB5dE2l72Ml1BYBprWDnnPTuCOMJ04d0meS1nSPpLQRq7GvEB8gm\ntdEscT/lc7jH7j7vgKLMapsf+OhJE6P1Mj/bgjVlCI89pkq+z2ylJdv9jtP0lrJg\nqs6Cd6tEfyiBlYsuPtkHblU+rQKBgQDNHM1kYl0GEHNlpSz47hmnyMXTOaCJrvoE\ndH9lc3DUqnfGt3a2NnmViBCu/tonasl/emy+Ovmj7faiN+pfv4YnVH43QKNSpXXP\neVyQKaiuJaZ1s1RXu3+Op817mohKle8BdTU9svOjiL90yTEbtcTal5+Rf8N+r4Ah\nQT9VJhvj9QKBgQCLI4mhgAMJ8Nrtm67rbEKg1rW34licVKnsJwlQSuJn6EeLiM2U\ny6y1Vz9U8c2lfXoQQOWe7T/m0rATR6iGBZCTNx5D+FuhuowqjLAwjlV7BI879htN\n/M602mYjyrW195Jn6HRmCaQ9M6Amg2gJ/0CBrFQlckHACuiu22e2Wwd1/QKBgQCG\nFJLrUSWQJkbZJj2cyEC7HpK6/kvEVT6YlPMGhY03Z+v+WcXfXQLjzdtiGbTP2Y24\nqHXXcMPp9k+oQTcTuiZfJWuQgM+C4ih+JM5uat0aYgBLppu28hlzTpwTdbQsVZC0\nekMAfy+nMmg9VpukipERd9ZWjZdlBCKVGorlBZFr1QKBgECRL7Vm+9OLFVL0WZ1M\nkCminLlKFSK+eMrgN6YzMScXi+f6IQnTaavxL/NL0JiWXDaOtoRw+F3QTk9kONue\niZ7I6RRdQtPcSgjH0EUqg41KRcLyZx3Ri0TJELqV/R1JC5kfzjnUsHyMJ/oILbFE\nFiCQursqzzZ5BhSVjbADO6nW\n-----END PRIVATE KEY-----\n",
        "client_email": "firebase-adminsdk-1bqqx@unity3dfirebase.iam.gserviceaccount.com",
        "client_id": "101717687535248857695",
        "auth_uri": "https://accounts.google.com/o/oauth2/auth",
        "token_uri": "https://oauth2.googleapis.com/token",
        "auth_provider_x509_cert_url": "https://www.googleapis.com/oauth2/v1/certs",
        "client_x509_cert_url": "https://www.googleapis.com/robot/v1/metadata/x509/firebase-adminsdk-1bqqx%40unity3dfirebase.iam.gserviceaccount.com"
      }), 
    databaseURL: "https://unity3dfirebase.firebaseio.com",
});

// Test Data Insert
router.get('/TestData', (req, res) => {
    const work = async () => {
        try{
            // 테스트 데이터
            var userData = new Object();
            userData.uid = "ABCCBAABCCBA";
            userData.name = "홍길동";
            userData.age = 27;

            console.log(userData.uid);

            // firestore 에서의 collection은 단순히 문서의 컨테이너이다.
            // db에 'user'라는 컬렉션이 없으면 자동으로 생성 후 사용하며
            // 있다면 그대로 사용한다.
            firebaseAdmin.firestore().collection('user')
            // doc() 이면 firestore가 자동으로 id로 문서가 생성한다.
            // doc('임의의 이름') 이면 사용자가 지정한 이름으로 문서가 생성된다.
            .doc(userData.uid)
            // JSON 데이터를 직접 넣는다.
            .set(userData)
            .then(() => {
                // 데이터 입력 성공 시...
                return res.send(true);
            }, (err) => {
                // 데이터 입력 실패 시...
                throw err;
            });
        } catch(err) {
            console.log(err);
            
            return res.send(false);
        }
    }

    work();
});

// 클라이언트가 보낸 데이터를 받은 후 DB에 저장
router.post('/postData', (req, res) => {
    const work = async () => {
        try{
            // 클라이언트에서 보낸 json 데이터
            var userData = req.body;
            
            console.log(userData.uid);

            // firestore 에서의 collection은 단순히 문서의 컨테이너이다.
            // db에 'user'라는 컬렉션이 없으면 자동으로 생성 후 사용하며
            // 있다면 그대로 사용한다.
            firebaseAdmin.firestore().collection('user')
            // doc() 이면 firestore가 자동으로 id로 문서가 생성한다.
            // doc('임의의 이름') 이면 사용자가 지정한 이름으로 문서가 생성된다.
            .doc(userData.uid)
            // JSON 데이터를 직접 넣는다.
            .set(userData)
            .then(() => {
                // 데이터 입력 성공 시...
                return res.send(true);
            }, (err) => {
                // 데이터 입력 실패 시...
                throw err;
            });
        } catch(err) {
            console.log(err);
            
            return res.send(false);
        }
    }

    work();
});

// 클라이언트가 보낸 UID 로 DB에서 검색 후 클라이언트에 JSON 되돌려준다.
router.get('/getSearchData', (req, res) => {
    const work = async () => {
        try{
            var uid = req.query.uid;

            // 문서 한 개만 찾은 후 클라로 보낸다.
            firebaseAdmin.firestore().collection('user').doc(uid).get()
            .then((snapshot) => {
                // 찾은 문서에서 데이터를 JSON 형식으로 얻는다.
                var userData = snapshot.data();

                return res.json(userData);
            }, (err) => {
                throw err;
            });

            // 만약 
        } catch(err) {
            console.log(err);

            return res.send(false);
        }
    }

    work();
});

// 클라이언트가 보낸 userData 로 DB에서 검색 후 특정 키값을 갱신한다.
router.post('/postRenewData', (req, res) => {
    const work = async () => {
        try{
            var user = req.body;

            firebaseAdmin.firestore().collection('user').doc(user.uid).update({
                name: "유저 이름 변경",
                // 특정 함수를 사용하여 수 타입의 데이터의 양을 지정된 수만큼 늘릴 수 있다.
                // 나이가 3 으로 저장되어 있는데 아래 함수를 사용할 경우 나이가 한살 늘어나
                // 4 로 수정된다.
                age: admin.firestore.FieldValue.increment(1)
            }).then((snapshot) => {
                // 성공 시...
                return res.send(true);
            }, (err) => {
                throw err;
            });
        } catch (err) {
            console.log(err);

            return res.send(false);
        }
    }
});

module.exports = router;